import 'package:fl_chart/fl_chart.dart';
import 'package:flutter/material.dart';

class SimpleVisualization extends StatelessWidget {
  const SimpleVisualization({
    super.key,
    required this.ecgSequence,
  });

  final List<double> ecgSequence;

  @override
  Widget build(BuildContext context) {
    final DISPLAY_NUM_OF_SAMPLE = 10 * 250;

    List<FlSpot> ecg = [];
    double index;
    double minX;
    double maxX;
    double maxY;
    double minY;

    final redrawingPart = 0;

    index = 0;
    minX = 0;
    maxX = DISPLAY_NUM_OF_SAMPLE.toDouble();
    maxY = 3;
    minY = -3;

    final a = ecgSequence.length - DISPLAY_NUM_OF_SAMPLE.toInt() < 0
        ? 0
        : ecgSequence.length - DISPLAY_NUM_OF_SAMPLE.toInt();
    final b = ecgSequence.length - redrawingPart;
    final c = ecgSequence.length;

    final remaining = ecgSequence.getRange(a, b);
    final updated = ecgSequence.getRange(b, c);
    final samples = updated.followedBy(remaining);

    for (double i in samples) {
      if (i > maxY) {
        i = maxY;
      } else if (i < minY) {
        i = minY;
      }
      ecg.add(FlSpot(index, i));
      index++;
    }

    return LineChart(
      LineChartData(
        minX: minX,
        maxX: maxX,
        minY: minY,
        maxY: maxY,
        backgroundColor: Colors.transparent,
        lineTouchData: LineTouchData(enabled: false),
        gridData: FlGridData(
          show: false,
        ),
        titlesData: FlTitlesData(
          show: false,
        ),
        borderData: FlBorderData(
          show: false,
        ),
        lineBarsData: [
          LineChartBarData(
            spots: ecg,
            isCurved: true,
            color: Colors.black,
            barWidth: 1,
            curveSmoothness: 0.15,
            preventCurveOverShooting: true,
            dotData: FlDotData(
              show: false,
            ),
          ),
        ],
      ),
    );
  }
}
