// ignore_for_file: public_member_api_docs

import 'dart:developer';
import 'dart:io';

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:flutter/material.dart';
import 'package:healthrian_ble_support/healthrian_ble_support.dart';
import 'package:path_provider/path_provider.dart';

part 'button_record_wearecg.g.dart';

@CopyWith()
class ButtonRecordWearEcg extends StatelessWidget {
  const ButtonRecordWearEcg({
    super.key,
    this.child,
  });

  final Widget? child;

  @override
  Widget build(BuildContext context) {
    return MaterialButton(
      onPressed: () {
        final streams = BLEManager().manageWearEcg12.streams;
        final stream = streams.bufferedFilterStreamEcg;
        log('ButtonRecordWearEcg was pressed');
        try {
          stream?.first.then(
            (value) async {
              log('Stream element exists.');
              if (value.l2.length < 2500) return;
              log('Length of result array is enough.');
              final res = value.toList();

              final appDocDir = await getApplicationDocumentsDirectory();
              final now = DateTime.now();
              final file = File('${appDocDir.path}/${now.millisecondsSinceEpoch}.json');
              log(file.path);

              const labels = [
                '"l1"',
                '"l2"',
                '"l3"',
                '"aVR"',
                '"aVL"',
                '"aVF"',
                '"v1"',
                '"v2"',
                '"v3"',
                '"v4"',
                '"v5"',
                '"v6"',
              ];

              await file.writeAsString(
                {
                  for (var i = 0; i < 12; i++)
                    labels[i]: res[i]
                        .map(
                          (e) => e.toStringAsFixed(4),
                        )
                        .toList()
                        .sublist(
                          res[i].length - 2500,
                          res[i].length,
                        ),
                }.toString(),
              );

              // final l2 = value.l2;
              //
              // final snackBar = SnackBar(
              //   content: Text('$l2'),
              // );
              //
              // log('$l2');
              //
              // ScaffoldMessenger.of(context).showSnackBar(
              //   snackBar,
              // );
            },
          );
        } catch (e) {
          log('$e');
        }
      },
      child: child,
    );
  }
}
