// ignore_for_file: public_member_api_docs

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:flutter/material.dart';
import 'package:healthrian_ble_support/healthrian_ble_support.dart';
import 'package:healthrian_visualization_support/'
    'healthrian_visualization_support.dart';

part 'ecg_waerecg.g.dart';

@CopyWith()
class EcgWearECG extends StatelessWidget {
  const EcgWearECG({
    super.key,
    this.onLoadingWidget,
    this.width,
    this.height,
    this.color = Colors.black,
    this.measureTime = 5,
    this.wrapperWidget,
    this.pivotColor = Colors.transparent,
    this.pivotStrokeWidth = 0,
    this.backgroundColor = Colors.transparent,
    this.ignoreChannels = const [],
  });

  final double measureTime;
  final Color color;
  final double? width;
  final double? height;
  final Widget? onLoadingWidget;
  final Color pivotColor;
  final double pivotStrokeWidth;

  final Color backgroundColor;

  final List<int> ignoreChannels;

  final Widget Function(List<Widget>)? wrapperWidget;

  @override
  Widget build(BuildContext context) {
    final module = BLEManager().wearEcg12.module;
    return EcgMonitor(
      key: key,
      module: module,
      onLoadingWidget: onLoadingWidget,
      width: width,
      height: height,
      color: color,
      backgroundColor: backgroundColor,
      measureTime: measureTime,
      pivotColor: pivotColor,
      pivotStrokeWidth: pivotStrokeWidth,
      wrapperWidget: wrapperWidget,
      ignoreChannels: ignoreChannels,
    );
  }
}
